import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  StopReplicationToReplicaRequest,
  StopReplicationToReplicaResponse,
} from "../models/models_0";
import {
  SecretsManagerClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../SecretsManagerClient";
export { __MetadataBearer, $Command };
export interface StopReplicationToReplicaCommandInput
  extends StopReplicationToReplicaRequest {}
export interface StopReplicationToReplicaCommandOutput
  extends StopReplicationToReplicaResponse,
    __MetadataBearer {}
export declare class StopReplicationToReplicaCommand extends $Command<
  StopReplicationToReplicaCommandInput,
  StopReplicationToReplicaCommandOutput,
  SecretsManagerClientResolvedConfig
> {
  readonly input: StopReplicationToReplicaCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: StopReplicationToReplicaCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: SecretsManagerClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    StopReplicationToReplicaCommandInput,
    StopReplicationToReplicaCommandOutput
  >;
  private serialize;
  private deserialize;
}
