import { TransformerContextProvider } from '@aws-amplify/graphql-transformer-interfaces';
import { ModelCreateInitSlotConfig, ModelCreateRequestConfig, ModelDefaultResponseConfig, ModelRequestConfig, ModelUpdateRequestConfig, ModelVTLGenerator } from './vtl-generator';
export declare class DynamoDBModelVTLGenerator implements ModelVTLGenerator {
    generateUpdateRequestTemplate(config: ModelUpdateRequestConfig, ctx: TransformerContextProvider): string;
    generateCreateRequestTemplate(config: ModelCreateRequestConfig, ctx: TransformerContextProvider): string;
    generateCreateInitSlotTemplate(config: ModelCreateInitSlotConfig, initializeIdField: boolean): string;
    generateDeleteRequestTemplate(config: ModelUpdateRequestConfig, ctx: TransformerContextProvider): string;
    generateUpdateInitSlotTemplate(config: ModelCreateInitSlotConfig): string;
    generateGetRequestTemplate(config: ModelRequestConfig, ctx: TransformerContextProvider): string;
    generateGetResponseTemplate(config: ModelUpdateRequestConfig): string;
    generateListRequestTemplate(config: ModelRequestConfig, ctx: TransformerContextProvider): string;
    generateSyncRequestTemplate(config: ModelRequestConfig): string;
    generateSubscriptionRequestTemplate(): string;
    generateSubscriptionResponseTemplate(): string;
    generateDefaultResponseMappingTemplate(config: ModelDefaultResponseConfig): string;
}
//# sourceMappingURL=dynamodb-vtl-generator.d.ts.map