import { AmplifyDynamoDbModelDataSourceStrategy, DataSourceStrategiesProvider, DefaultDynamoDbModelDataSourceStrategy, ImportedAmplifyDynamoDbModelDataSourceStrategy, ModelDataSourceStrategy, ModelDataSourceStrategyDbType, ModelDataSourceStrategySqlDbType, SQLLambdaModelDataSourceStrategy } from '@aws-amplify/graphql-transformer-interfaces';
import { ImportedRDSType } from '../types';
export declare const getModelDataSourceNameForTypeName: (ctx: DataSourceStrategiesProvider, typeName: string) => string;
export declare const getImportedRDSTypeFromStrategyDbType: (dbType: ModelDataSourceStrategyDbType) => ImportedRDSType;
export declare const getModelDataSourceStrategy: (ctx: DataSourceStrategiesProvider, typename: string) => ModelDataSourceStrategy;
export declare const isImportedAmplifyDynamoDbModelDataSourceStrategy: (strategy: ModelDataSourceStrategy) => strategy is ImportedAmplifyDynamoDbModelDataSourceStrategy;
export declare const isAmplifyDynamoDbModelDataSourceStrategy: (strategy: ModelDataSourceStrategy) => strategy is AmplifyDynamoDbModelDataSourceStrategy;
export declare const isDefaultDynamoDbModelDataSourceStrategy: (strategy: ModelDataSourceStrategy) => strategy is DefaultDynamoDbModelDataSourceStrategy;
export declare const isDynamoDbModel: (ctx: DataSourceStrategiesProvider, typename: string) => boolean;
export declare const isDynamoDbType: (dbType: ModelDataSourceStrategyDbType) => dbType is "DYNAMODB";
export declare const isModelType: (ctx: DataSourceStrategiesProvider, typename: string) => boolean;
export declare const isSqlDbType: (dbType: ModelDataSourceStrategyDbType) => dbType is ModelDataSourceStrategySqlDbType;
export declare const isSqlModel: (ctx: DataSourceStrategiesProvider, typename: string) => boolean;
export declare const isSqlStrategy: (strategy: ModelDataSourceStrategy) => strategy is SQLLambdaModelDataSourceStrategy;
export declare const getStrategyDbTypeFromModel: (ctx: DataSourceStrategiesProvider, typename: string) => ModelDataSourceStrategyDbType;
export declare const normalizeDbType: (candidate: string) => ModelDataSourceStrategyDbType;
//# sourceMappingURL=model-datasource-strategy-utils.d.ts.map