import { BackendIdentifier } from '@aws-amplify/plugin-types';
/**
 * Provides static methods for converting BackendIdentifier to/from a stack name string
 */
export declare class BackendIdentifierConversions {
    /**
     * Convert a stack name to a BackendIdentifier
     *
     * If the stack name is ambiguous, undefined is returned
     */
    static fromStackName(stackName?: string): BackendIdentifier | undefined;
    /**
     * Convert a BackendIdentifier to a stack name.
     *
     * !!!DANGER!!!
     * !!!DO NOT CHANGE THIS UNLESS YOU ARE 100% SURE YOU UNDERSTAND THE CONSEQUENCES!!!
     *
     * Changing this method will change how stack names are generated which could be a massive breaking change for existing Amplify stacks.
     */
    static toStackName(backendId: BackendIdentifier): string;
}
//# sourceMappingURL=backend_identifier_conversions.d.ts.map