"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FunctionResourceIDs = void 0;
const md5_1 = __importDefault(require("md5"));
const util_1 = require("./util");
class FunctionResourceIDs {
    static FunctionDataSourceID(name, region, accountId) {
        return `${(0, util_1.simplifyName)(name)}${(0, util_1.simplifyName)(region || '')}${accountId || ''}LambdaDataSource`;
    }
    static FunctionIAMRoleID(name, region, accountId) {
        return `${FunctionResourceIDs.FunctionDataSourceID(name, region, accountId)}Role`;
    }
    static FunctionIAMRoleName(name, withEnv = false) {
        if (withEnv) {
            return `${(0, util_1.simplifyName)(name).slice(0, 22)}${(0, md5_1.default)(name).slice(0, 4)}`;
        }
        return `${(0, util_1.simplifyName)(name).slice(0, 32)}${(0, md5_1.default)(name).slice(0, 4)}`;
    }
    static FunctionAppSyncFunctionConfigurationID(name, region, accountId) {
        return `Invoke${FunctionResourceIDs.FunctionDataSourceID(name, region, accountId)}`;
    }
}
exports.FunctionResourceIDs = FunctionResourceIDs;
//# sourceMappingURL=FunctionResourceIDs.js.map